;*******************************************************************
;               Listing 2.4 - Universalregisterprfung
;*******************************************************************
;
;
        LIST    p=16C55 ; PIC16C55 is the target processor

; common equates

indir	equ	00
tmr0	equ	01
pcl	equ	02
status  equ     03      
fsr	equ	04
porta	equ	05
portb   equ     06     
portc	equ	07

wka	equ	08
wkb	equ	09
lastreg	equ	01fh	;last register address

carry	equ	0
zero	equ	2

z	equ	0
in	equ	0ffh
out	equ	0

;*******************************************

; dedicated equates

firstreg	equ	06h	; 1. zu prfendes Register

lastreg 	equ	20h	; letztes zu prfendes Register + 1 

;*******************************************************************

	org 	0

start:
	movlw	firstreg	; initialisieren
	movwf	fsr		; firstreg = 1. Register
loop1:	movfw	fsr 		; Adrezeiger -> zu prfendes Register
	movwf	indf
	inc	fsr		; Adrezeigger erhhen
	movlw	lastreg		; lastreg = letztes Register + 1
	subwf	fsr,0		; letztes Register ?
	skpz			; ja - zum Lesen
	goto	loop1		; nein - weiter fllen

	movlw 	firstreg	; erneut initialisieren
	movwf	fsr
loop2:	movfw	fsr		; Adrezeiger = zu prfendes Register ?
	subwf	indf,0
	skpz			; ja = o.k.
	goto 	error		; nein = Fehler
	inc 	fsr
	movlw	lastreg		; lastreg = letztes Register + 1
	subwf	fsr,0		; letztes Register ?
	skpz			; ja - Schleife verlassen
	goto	loop1		; nein - weiter prfen

ende:	goto	ende		; fertig; o.k.

error:	goto	error		; Fehler
;**********************************************************************
;      first instruction
;**********************************************************************

        org     01FFh
        goto    start
;
     END


