unit ausgangunit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TAusgang = class(TForm)
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Ausgang: TAusgang;
  portpin : array [1..8] of tbitbtn;
implementation

uses pfsimUnit, speicherbox, IOPORTUNIT;

{$R *.DFM}



procedure TAusgang.FormShow(Sender: TObject);
var indexio,  index: integer;
    inhaltstr,
    indexstr : string;
begin
  for indexio := 1 to portanzahl do
  begin
    if ioportbox.ioport[indexio].selected = true then
    begin
      caption := 'Port ';
      {      showmessage ('ioport-inhalt:' + inttostr (ioport[index].inhalt));}
      inhaltstr := inttohex (ioport[indexio].inhalt, 2);
      caption := caption  + inttostr (indexio)+': ';
      caption := caption + '  ' + inttostr (ioport[indexio].inhalt);
      inhaltstr := hextobin (inhaltstr);
      {inhaltstr := copy (inhaltstr, 1, 4) + copy (inhaltstr, 6, 4);}
     { showmessage ('inhaltio: ' + inhaltstr);}
      for index := 1 to portbreite do
      begin
        if inhaltstr[index] = '1' then
        begin
          portpin[index].glyph.loadfromfile ('ledein.bmp');
        end
        else
        begin
          portpin[index].glyph.loadfromfile ('ledaus.bmp');
        end;
      end;
    end;
  end;
end;

procedure TAusgang.FormCreate(Sender: TObject);
var index : integer;
begin
  for index := 1 to 8 do
  begin
    portpin [index]:= tbitbtn.create (main);
    portpin [index].parent := self;
    portpin [index].height := 40;
    portpin [index].caption := inttostr (index);
    portpin [index]. top := 0;
    portpin [index]. width := 25;
    portpin [index].left :=  (index - 1) * 30 + 10;
    portpin [index].layout:= blglyphtop;
    portpin [index].visible :=  true;

  end;
end;

procedure TAusgang.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  caption := '';
end;

end. 
