unit schalter;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Buttons, unit1, ExtCtrls;

type
  tschalterbox = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Laden1: TMenuItem;
    Speichern1: TMenuItem;
    Speichernunter1: TMenuItem;
    Schlieen1: TMenuItem;
    Beenden1: TMenuItem;
    Bearbeiten1: TMenuItem;
    Zustand1: TMenuItem;
    Wert1: TMenuItem;
    Hilfe1: TMenuItem;
    Hilfetext1: TMenuItem;
    Info1: TMenuItem;
    Initialisieren1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;

    procedure Beenden1Click(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Schlieen1Click(Sender: TObject);
    procedure Initialisieren1Click(Sender: TObject);
    procedure Speichern1Click(Sender: TObject);
    procedure Speichernunter1Click(Sender: TObject);
    procedure Laden1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
{    procedure BitBtn1Click(Sender: TObject);}
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  schalterbox: Tschalterbox;
  index : integer;
  ist : integer;
  implementation

uses Infobox;

{$R *.DFM}

{schiet das fenster schalterbox}
procedure Tschalterbox.Beenden1Click(Sender: TObject);
begin
  close;
end;

{erzeugt einen Speedbutton}
function makebutton (index: integer) : tswitch;
var makeswitch : tswitch;
begin
  if switch[index] = nil then
  begin
    makeswitch:= tswitch.create(schalterbox);
    makeswitch.parent := schalterbox;
  end;
  makeswitch.height := 35;
  makeswitch.top := ((index-1) mod 8) * 35 + 30;
  makeswitch.width := 80;
  makeswitch.left := ((index-1) div 8) * 90 + 210;
  makeswitch.caption := inttostr (index);
  makeswitch.margin:= 2;
  makeswitch.numglyphs:= 1;
  makeswitch.glyph.loadfromfile ('kippschalter-0.bmp');
  makeswitch.visible := true;
  makebutton:= makeswitch;
end;

{Erzeugt "portanzahl" SpeedButtons im Fenster "schalterbox"}
procedure Tschalterbox.Initialisieren1Click(Sender: TObject);
var schalterstr : string ;
begin
  for index := 1 to portanzahl do
  begin
    switch[index]:= makebutton (index);
  end;
  wert1.enabled := true;
  zustand1.enabled := true;
  initialisieren1.enabled := false;
  schlieen1.enabled:= true;
end;

{zeigt das Infofenster an}
procedure Tschalterbox.Info1Click(Sender: TObject);
begin
  aboutbox.show;
end;

procedure Tschalterbox.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 { if switch[1] = sender then
    if ist=1 then
    begin
      ist := 27;
      switch[index].glyph.loadfromfile ('kippschalter-1.bmp');
    end
    else
    begin
      switch[index].glyph.loadfromfile ('kippschalter-0.bmp');
      ist := 1;
    end;}
  showmessage (inttostr (x)+ ' ' + inttostr (y));

end;

procedure Tschalterbox.Schlieen1Click(Sender: TObject);
var i : integer;
begin
  for i := 1 to portanzahl do
  begin
    {switch[i].free;}
    switch[i].visible := false;
    schlieen1.enabled := false;
    initialisieren1.enabled := true;
    wert1.enabled := false;
    zustand1.enabled := false;
    memo1.clear;
    label2.caption:= 'unbekannt';
  end;
end;

procedure Tschalterbox.Speichern1Click(Sender: TObject);
begin
  if opendialog1.filename <> '' then
  begin
    memo1.lines.savetofile (opendialog1.filename);
  end
  else
  begin
    speichernunter1click(sender);
  end;
end;

procedure Tschalterbox.Speichernunter1Click(Sender: TObject);
begin
  with savedialog1 do
  if execute then
  Begin
    memo1.lines.savetofile (filename);
    label2.caption:= extractfilename (filename);
    opendialog1.filename:= filename;
  end;
end;

procedure Tschalterbox.Laden1Click(Sender: TObject);
begin
  with opendialog1 do
  if execute then
  begin
    memo1.lines.loadfromfile (filename);
    label2.caption:= extractfilename (filename);
    initialisieren1.enabled:= false;
    wert1.enabled:= true;
    zustand1.enabled:= true;
    schlieen1.enabled:= true;
  end;
end;

{procedure Tschalterbox.BitBtn1Click(Sender: TObject);
begin
  if ist=1 then
  begin
     ist := 27;
     BitBtn1.glyph.loadfromfile ('kippschalter-1.bmp');
   end
   else
   begin
     BitBtn1.glyph.loadfromfile ('kippschalter-0.bmp');
     ist := 1;
   end;
end; }

procedure Tschalterbox.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action:= cafree;
end;

end.
